package hr.fer.tel.ruazosa;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import javax.transaction.Transactional;

import hr.fer.tel.ruazosa.entities.Account;
import hr.fer.tel.ruazosa.entities.Course;
import hr.fer.tel.ruazosa.entities.Person;
import hr.fer.tel.ruazosa.repositories.AccountRepository;
import hr.fer.tel.ruazosa.repositories.CourseRepository;
import hr.fer.tel.ruazosa.repositories.PersonRepository;

@SpringBootApplication
public class LecturesApplication implements CommandLineRunner {
	@Autowired
	private PersonRepository repo;

	@Autowired
	private CourseRepository crepo;

	@Autowired
	private AccountRepository arepo;

	public static void main(String[] args) {
		SpringApplication.run(LecturesApplication.class, args);
	}

	@Override
	@Transactional
	public void run(String... args) throws Exception {
		arepo.save(new Account("admin", "admin"));
		arepo.save(new Account("user", "user"));

		Course c = new Course("RUAZOSA", "Razvoj usluga i aplikacija za operacijski sustav Android");
		crepo.save(c);

		c = new Course("KP", "Konkurentno programiranje");
		crepo.save(c);

		c = new Course("RASSUS", "Raspodijeljeni sustavi");
		crepo.save(c);

		c = new Course("OOP", "Objektno orijentirano programiranje");
		crepo.save(c);

		Person p = new Person("Pero", "Perić", "1111", "C15-15");
		c = crepo.findByName("RUAZOSA").get(0);
		p.getTeachingCourses().add(c);
		c.setTeacher(p);
		repo.save(p);

		p = new Person("Iva", "Ivić", "555", "C0-32");
		p.getEnrolledCourses().add(c);
		c.getStudents().add(p);
		repo.save(p);

		p = new Person("Jura", "Jurić", "333", "C3-81");
		p.getEnrolledCourses().add(c);
		c.getStudents().add(p);
		repo.save(p);
	}
}
