package hr.fer.tel.ruazosa.representations;

import org.springframework.beans.BeanUtils;
import org.springframework.stereotype.Service;

import java.util.LinkedList;
import java.util.List;

import hr.fer.tel.ruazosa.entities.Person;

@Service
public class PersonAssembler {

    public PersonResource toResource(Person person) {
        PersonResource resource = new PersonResource();
        BeanUtils.copyProperties(person, resource);

        return resource;
    }

    public List<ShortPersonResource> toListResource(Iterable<Person> persons) {
        List<ShortPersonResource> resources = new LinkedList<ShortPersonResource>();
        for(Person p: persons)
            resources.add(toShortResource(p));

        return resources;
    }

    public ShortPersonResource toShortResource(Person person) {
        ShortPersonResource resource = new ShortPersonResource();
        resource.setId(person.getId());
        resource.setName(person.getFirstName() + " " + person.getLastName());
        return resource;
    }

    public Person toEntity(PersonResource personResource) {
        Person person = new Person();
        BeanUtils.copyProperties(personResource, person);
        return person;
    }
}
