package hr.fer.tel.ruazosa.representations;

import org.springframework.data.rest.webmvc.ResourceNotFoundException;

public class RepresentationUtility {
    public static <R> R resourceNotFoundIfNull(R r) {
        return resourceNotFoundIfNull(r, null);
    }

    public static <R> R resourceNotFoundIfNull(R r, String message) {
        if(r == null)
            throw new ResourceNotFoundException();

        return r;
    }

    public static <R> R badRequestIfNull(R r, String message) {
        if(r == null)
            throw new BadRequestException(message);

        return r;
    }
}
