package hr.fer.tel.ruazosa.services;

import org.springframework.security.access.prepost.PreAuthorize;

import hr.fer.tel.ruazosa.entities.Course;

public interface CourseService {
    @PreAuthorize("hasAuthority('ROLE_USER')")
    public Iterable<Course> findAll();

    @PreAuthorize("hasAuthority('ROLE_USER')")
    public Course getWithId(Long id);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public Course save(Course convertToEntity);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public void update(Course person);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public void delete(Long id);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public void enrollPersonToCourse(Long courseId, Long studentId);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public void unenrollPersonToCourse(Long courseId, Long studentId);
}
