package hr.fer.tel.ruazosa.services;

import org.springframework.security.access.prepost.PreAuthorize;

import hr.fer.tel.ruazosa.entities.Person;

public interface PersonService {
    @PreAuthorize("hasAuthority('ROLE_USER')")
    public Iterable<Person> findAll();

    @PreAuthorize("hasAuthority('ROLE_USER')")
    public Person getWithId(Long id);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public Person save(Person convertToEntity);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public void update(Person person);

    @PreAuthorize("hasAuthority('ROLE_ADMIN')")
    public void delete(String id);
}
